//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  Silver
#property indicator_color2  Silver
#property indicator_color3  PaleVioletRed
#property indicator_color4  Red
#property indicator_color5  Lime
#property indicator_width2  1
#property indicator_width3  1
#property indicator_level1  0
#define PREFIX "MACD_1"
//
//
//
//
//

extern double FastPeriod   = 14;
extern int    FastOrder    =  2;
extern double SlowPeriod   = 34;
extern int    SlowOrder    =  2;
extern int    SignalPeriod =  9;
extern int    SignalOrder  =  2;
extern int    SignalMethod = MODE_EMA;
extern int    Price        = PRICE_CLOSE;
extern string _JMA_    = "parameter for JMA";
extern bool JMA_par    = true;         
extern int J_Phase     = 0;      
extern int JMAPeriod   = 5;       
extern bool JMA_sig    = true;
string ArrowsIdentifier = "Gaussian MACD Arrows";             
//
//
//
//
//

double macd[];
double macdl[];
double signal[];
double v11[];
double v22[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{  if(JJMASeriesResize(4) != 4)   return(-1);
   SetIndexBuffer(0,macd); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macdl);
   SetIndexBuffer(2,signal);
   SetIndexBuffer(3, v11);      
   SetIndexBuffer(4, v22);      
      IndicatorShortName("MACD gaussian ("+DoubleToStr(FastPeriod,2)+","+DoubleToStr(SlowPeriod,2)+","+SignalPeriod+")");
   return(0);
}
int deinit()   {  ArrowRemover(); return(0);    } 
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{ 
  int counted_bars = IndicatorCounted();
  int MaxBar, reset, scale;
   if(Bars < FastPeriod) return(0);  
   counted_bars = IndicatorCounted();
   if(counted_bars < 0) return (-1);
   if(counted_bars > 0) counted_bars--;   
   MaxBar=Bars-1;
   int limit=Bars-counted_bars-1;
         
   //
   //
   //
   //
   //
    
      for(int i = limit; i>=0; i--)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         macd[i]  = iGFilter(price,FastPeriod,FastOrder,i,0)-iGFilter(price,SlowPeriod,SlowOrder,i,1);
         macdl[i] = macd[i];
      }            
      for(i = limit; i>=0; i--)
         if (SignalMethod==4)
               signal[i] = iGFilter(macd[i],SignalPeriod,SignalOrder,i,2);
         else  signal[i] = iMAOnArray(macd,0,SignalPeriod,0,SignalMethod,i);

//+---------------+   
      if(JMA_par)     
      for (i=limit; i>=0; i--)   {
      v11[i] = JJMASeries(0,0,MaxBar,limit,J_Phase,JMAPeriod,macdl[i],i,reset);   
      v22[i] = JJMASeries(1,0,MaxBar,limit,J_Phase,JMAPeriod,signal[i],i,reset);  
         }  
           
      if(JMA_sig)    
      for (i=limit; i>=0; i--)  {
      ArrowCleaner(Time[i]);
      if (v22[i] < signal[i] && v22[i+1] > signal[i+1] && v22[i-1] < signal[i-1])        manageArrow(i, Lime,233,false);
      if (v11[i] < signal[i] && v11[i+1] > signal[i+1] && v11[i-1] < signal[i-1])        manageArrow(i, Red, 234, true); 
          
           }      
         
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.141592653589793238462643

int    periods[3];
double coeffs[][9];
double filters[][3];
double iGFilter(double price, int period, int order, int i, int instanceNo=0)
{
   if (ArrayRange(filters,0)!=Bars)  ArrayResize(filters,Bars);
   if (ArrayRange(coeffs,0)<order+1) ArrayResize(coeffs,order+1);
   if (periods[instanceNo]!=period)
   {
      periods[instanceNo]=period;
         double b = (1.0 - MathCos(2.0*Pi/period))/(MathPow(MathSqrt(2.0),2.0/order) - 1.0);
         double a = -b + MathSqrt(b*b + 2.0*b);
         for(int r=0; r<=order; r++)
         {
             coeffs[r][instanceNo*3+0] = fact(order)/(fact(order-r)*fact(r));
             coeffs[r][instanceNo*3+1] = MathPow(    a,r);
             coeffs[r][instanceNo*3+2] = MathPow(1.0-a,r);
         }
   }

   //
   //
   //
   //
   //
   
   i = Bars-i-1;
   filters[i][instanceNo] = price*coeffs[order][instanceNo*3+1];
      double sign = 1;
         for (r=1; r <= order; r++, sign *= -1.0)
                  filters[i][instanceNo] += sign*coeffs[r][instanceNo*3+0]*coeffs[r][instanceNo*3+2]*filters[i-r][instanceNo];
   return(filters[i][instanceNo]);
}

//
//
//
//
//

double fact(int n)
{
   double a=1;
         for(int i=1; i<=n; i++) a*=i;
   return(a);
}
#include <JJMASeries.mqh>

  
//---- Arrow Drawer 
void manageArrow(int i,color colors,int codes,bool up)
  {
   string ArrowName = ArrowsIdentifier+":"+Time[i];
   double Gap = iATR(Symbol(),Period(),20,i);   
   ObjectCreate(ArrowName,OBJ_ARROW,0,Time[i],0);
   ObjectSet(ArrowName,OBJPROP_ARROWCODE,codes);
   ObjectSet(ArrowName,OBJPROP_COLOR,colors);
   if (up)  ObjectSet(ArrowName,OBJPROP_PRICE1,High[i]+Gap);
   else     ObjectSet(ArrowName,OBJPROP_PRICE1,Low [i]-Gap);
  }

//---- Arrow Remover
void ArrowRemover()
  {
   string LookFor = ArrowsIdentifier+":";
   int LookForLength = StringLen(LookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
     {
      string objectName = ObjectName(i);
      if (StringSubstr(objectName,0,LookForLength) == LookFor)  ObjectDelete(objectName);
     }
  }

//---- Arrow Cleaner
void ArrowCleaner(datetime time)
  {
   string LookFor = ArrowsIdentifier+":"+time; ObjectDelete(LookFor);
  }